// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information. 

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{

    /// <summary>
    /// Defines values for VirtualMachineSizeTypes.
    /// </summary>
    public class VirtualMachineSizeTypes
    {
        public static readonly VirtualMachineSizeTypes  BasicA0 = new VirtualMachineSizeTypes("Basic_A0");
        public static readonly VirtualMachineSizeTypes  BasicA1 = new VirtualMachineSizeTypes("Basic_A1");
        public static readonly VirtualMachineSizeTypes  BasicA2 = new VirtualMachineSizeTypes("Basic_A2");
        public static readonly VirtualMachineSizeTypes  BasicA3 = new VirtualMachineSizeTypes("Basic_A3");
        public static readonly VirtualMachineSizeTypes  BasicA4 = new VirtualMachineSizeTypes("Basic_A4");
        public static readonly VirtualMachineSizeTypes  StandardA0 = new VirtualMachineSizeTypes("Standard_A0");
        public static readonly VirtualMachineSizeTypes  StandardA1 = new VirtualMachineSizeTypes("Standard_A1");
        public static readonly VirtualMachineSizeTypes  StandardA2 = new VirtualMachineSizeTypes("Standard_A2");
        public static readonly VirtualMachineSizeTypes  StandardA3 = new VirtualMachineSizeTypes("Standard_A3");
        public static readonly VirtualMachineSizeTypes  StandardA4 = new VirtualMachineSizeTypes("Standard_A4");
        public static readonly VirtualMachineSizeTypes  StandardA5 = new VirtualMachineSizeTypes("Standard_A5");
        public static readonly VirtualMachineSizeTypes  StandardA6 = new VirtualMachineSizeTypes("Standard_A6");
        public static readonly VirtualMachineSizeTypes  StandardA7 = new VirtualMachineSizeTypes("Standard_A7");
        public static readonly VirtualMachineSizeTypes  StandardA8 = new VirtualMachineSizeTypes("Standard_A8");
        public static readonly VirtualMachineSizeTypes  StandardA9 = new VirtualMachineSizeTypes("Standard_A9");
        public static readonly VirtualMachineSizeTypes  StandardA10 = new VirtualMachineSizeTypes("Standard_A10");
        public static readonly VirtualMachineSizeTypes  StandardA11 = new VirtualMachineSizeTypes("Standard_A11");
        public static readonly VirtualMachineSizeTypes  StandardD1 = new VirtualMachineSizeTypes("Standard_D1");
        public static readonly VirtualMachineSizeTypes  StandardD2 = new VirtualMachineSizeTypes("Standard_D2");
        public static readonly VirtualMachineSizeTypes  StandardD3 = new VirtualMachineSizeTypes("Standard_D3");
        public static readonly VirtualMachineSizeTypes  StandardD4 = new VirtualMachineSizeTypes("Standard_D4");
        public static readonly VirtualMachineSizeTypes  StandardD11 = new VirtualMachineSizeTypes("Standard_D11");
        public static readonly VirtualMachineSizeTypes  StandardD12 = new VirtualMachineSizeTypes("Standard_D12");
        public static readonly VirtualMachineSizeTypes  StandardD13 = new VirtualMachineSizeTypes("Standard_D13");
        public static readonly VirtualMachineSizeTypes  StandardD14 = new VirtualMachineSizeTypes("Standard_D14");
        public static readonly VirtualMachineSizeTypes  StandardD1V2 = new VirtualMachineSizeTypes("Standard_D1_v2");
        public static readonly VirtualMachineSizeTypes  StandardD2V2 = new VirtualMachineSizeTypes("Standard_D2_v2");
        public static readonly VirtualMachineSizeTypes  StandardD3V2 = new VirtualMachineSizeTypes("Standard_D3_v2");
        public static readonly VirtualMachineSizeTypes  StandardD4V2 = new VirtualMachineSizeTypes("Standard_D4_v2");
        public static readonly VirtualMachineSizeTypes  StandardD5V2 = new VirtualMachineSizeTypes("Standard_D5_v2");
        public static readonly VirtualMachineSizeTypes  StandardD11V2 = new VirtualMachineSizeTypes("Standard_D11_v2");
        public static readonly VirtualMachineSizeTypes  StandardD12V2 = new VirtualMachineSizeTypes("Standard_D12_v2");
        public static readonly VirtualMachineSizeTypes  StandardD13V2 = new VirtualMachineSizeTypes("Standard_D13_v2");
        public static readonly VirtualMachineSizeTypes  StandardD14V2 = new VirtualMachineSizeTypes("Standard_D14_v2");
        public static readonly VirtualMachineSizeTypes  StandardD15V2 = new VirtualMachineSizeTypes("Standard_D15_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS1 = new VirtualMachineSizeTypes("Standard_DS1");
        public static readonly VirtualMachineSizeTypes  StandardDS2 = new VirtualMachineSizeTypes("Standard_DS2");
        public static readonly VirtualMachineSizeTypes  StandardDS3 = new VirtualMachineSizeTypes("Standard_DS3");
        public static readonly VirtualMachineSizeTypes  StandardDS4 = new VirtualMachineSizeTypes("Standard_DS4");
        public static readonly VirtualMachineSizeTypes  StandardDS11 = new VirtualMachineSizeTypes("Standard_DS11");
        public static readonly VirtualMachineSizeTypes  StandardDS12 = new VirtualMachineSizeTypes("Standard_DS12");
        public static readonly VirtualMachineSizeTypes  StandardDS13 = new VirtualMachineSizeTypes("Standard_DS13");
        public static readonly VirtualMachineSizeTypes  StandardDS14 = new VirtualMachineSizeTypes("Standard_DS14");
        public static readonly VirtualMachineSizeTypes  StandardDS1V2 = new VirtualMachineSizeTypes("Standard_DS1_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS2V2 = new VirtualMachineSizeTypes("Standard_DS2_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS3V2 = new VirtualMachineSizeTypes("Standard_DS3_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS4V2 = new VirtualMachineSizeTypes("Standard_DS4_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS5V2 = new VirtualMachineSizeTypes("Standard_DS5_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS11V2 = new VirtualMachineSizeTypes("Standard_DS11_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS12V2 = new VirtualMachineSizeTypes("Standard_DS12_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS13V2 = new VirtualMachineSizeTypes("Standard_DS13_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS14V2 = new VirtualMachineSizeTypes("Standard_DS14_v2");
        public static readonly VirtualMachineSizeTypes  StandardDS15V2 = new VirtualMachineSizeTypes("Standard_DS15_v2");
        public static readonly VirtualMachineSizeTypes  StandardG1 = new VirtualMachineSizeTypes("Standard_G1");
        public static readonly VirtualMachineSizeTypes  StandardG2 = new VirtualMachineSizeTypes("Standard_G2");
        public static readonly VirtualMachineSizeTypes  StandardG3 = new VirtualMachineSizeTypes("Standard_G3");
        public static readonly VirtualMachineSizeTypes  StandardG4 = new VirtualMachineSizeTypes("Standard_G4");
        public static readonly VirtualMachineSizeTypes  StandardG5 = new VirtualMachineSizeTypes("Standard_G5");
        public static readonly VirtualMachineSizeTypes  StandardGS1 = new VirtualMachineSizeTypes("Standard_GS1");
        public static readonly VirtualMachineSizeTypes  StandardGS2 = new VirtualMachineSizeTypes("Standard_GS2");
        public static readonly VirtualMachineSizeTypes  StandardGS3 = new VirtualMachineSizeTypes("Standard_GS3");
        public static readonly VirtualMachineSizeTypes  StandardGS4 = new VirtualMachineSizeTypes("Standard_GS4");
        public static readonly VirtualMachineSizeTypes  StandardGS5 = new VirtualMachineSizeTypes("Standard_GS5");

        private string value;

        public VirtualMachineSizeTypes(string sizeName)
        {
            this.value = sizeName;
        }

        public override string ToString()
        {
            return this.value;
        }

        public override int GetHashCode()
        {
            return this.value.GetHashCode();
        }

        public override bool Equals(object obj)
        {

            string value = this.ToString();
            if (!(obj is VirtualMachineSizeTypes))
            {
                return false;
            }

            if (obj == this)
            {
                return true;
            }
            VirtualMachineSizeTypes rhs = (VirtualMachineSizeTypes)obj;
            if (value == null)
            {
                return rhs.value == null;
            }
            return value.Equals(rhs.value);
        }
    }
}
